Index: src/Actions/CommandAction/BondLengthTableAction.cpp
===================================================================
--- src/Actions/CommandAction/BondLengthTableAction.cpp	(revision 47d0416c5a62d6d7eb14391e14c7f3f576fb1673)
+++ src/Actions/CommandAction/BondLengthTableAction.cpp	(revision 41a467397fe65de7b369f9989fc26e6e18070f2e)
@@ -24,8 +24,7 @@
 #include "CodePatterns/MemDebug.hpp"
 
-#include "Graph/BondGraph.hpp"
-#include "config.hpp"
 #include "CodePatterns/Log.hpp"
 #include "CodePatterns/Verbose.hpp"
+#include "Graph/BondGraph.hpp"
 #include "World.hpp"
 
Index: src/Actions/FragmentationAction/FragmentationAction.cpp
===================================================================
--- src/Actions/FragmentationAction/FragmentationAction.cpp	(revision 47d0416c5a62d6d7eb14391e14c7f3f576fb1673)
+++ src/Actions/FragmentationAction/FragmentationAction.cpp	(revision 41a467397fe65de7b369f9989fc26e6e18070f2e)
@@ -21,13 +21,9 @@
 
 #include "atom.hpp"
-#include "Graph/BondGraph.hpp"
-#include "config.hpp"
 #include "CodePatterns/Log.hpp"
-#include "CodePatterns/Verbose.hpp"
 #include "Fragmentation/Fragmentation.hpp"
 #include "Fragmentation/HydrogenSaturation_enum.hpp"
 #include "Graph/DepthFirstSearchAnalysis.hpp"
 #include "molecule.hpp"
-#include "Descriptors/MoleculeDescriptor.hpp"
 #include "World.hpp"
 
Index: src/Actions/GraphAction/SubgraphDissectionAction.cpp
===================================================================
--- src/Actions/GraphAction/SubgraphDissectionAction.cpp	(revision 47d0416c5a62d6d7eb14391e14c7f3f576fb1673)
+++ src/Actions/GraphAction/SubgraphDissectionAction.cpp	(revision 41a467397fe65de7b369f9989fc26e6e18070f2e)
@@ -25,5 +25,4 @@
 #include "atom.hpp"
 #include "Bond/bond.hpp"
-#include "config.hpp"
 #include "CodePatterns/Log.hpp"
 #include "CodePatterns/Verbose.hpp"
Index: src/Actions/MoleculeAction/FillVoidWithMoleculeAction.cpp
===================================================================
--- src/Actions/MoleculeAction/FillVoidWithMoleculeAction.cpp	(revision 47d0416c5a62d6d7eb14391e14c7f3f576fb1673)
+++ src/Actions/MoleculeAction/FillVoidWithMoleculeAction.cpp	(revision 41a467397fe65de7b369f9989fc26e6e18070f2e)
@@ -21,14 +21,13 @@
 
 #include "atom.hpp"
-#include "Graph/BondGraph.hpp"
-#include "Tesselation/boundary.hpp"
 #include "CodePatterns/Verbose.hpp"
-#include "config.hpp"
 #include "Descriptors/MoleculeIdDescriptor.hpp"
 #include "Descriptors/MoleculeOrderDescriptor.hpp"
+#include "Graph/BondGraph.hpp"
 #include "molecule.hpp"
 #include "MoleculeListClass.hpp"
 #include "Parser/FormatParserInterface.hpp"
 #include "Parser/FormatParserStorage.hpp"
+#include "Tesselation/boundary.hpp"
 #include "World.hpp"
 
Index: src/Actions/MoleculeAction/FillWithMoleculeAction.cpp
===================================================================
--- src/Actions/MoleculeAction/FillWithMoleculeAction.cpp	(revision 47d0416c5a62d6d7eb14391e14c7f3f576fb1673)
+++ src/Actions/MoleculeAction/FillWithMoleculeAction.cpp	(revision 41a467397fe65de7b369f9989fc26e6e18070f2e)
@@ -21,14 +21,13 @@
 
 #include "atom.hpp"
-#include "Graph/BondGraph.hpp"
-#include "Tesselation/boundary.hpp"
 #include "CodePatterns/Verbose.hpp"
-#include "config.hpp"
 #include "Descriptors/MoleculeIdDescriptor.hpp"
 #include "Descriptors/MoleculeOrderDescriptor.hpp"
+#include "Graph/BondGraph.hpp"
 #include "molecule.hpp"
 #include "MoleculeListClass.hpp"
 #include "Parser/FormatParserInterface.hpp"
 #include "Parser/FormatParserStorage.hpp"
+#include "Tesselation/boundary.hpp"
 #include "World.hpp"
 
Index: src/Actions/MoleculeAction/SaveAdjacencyAction.cpp
===================================================================
--- src/Actions/MoleculeAction/SaveAdjacencyAction.cpp	(revision 47d0416c5a62d6d7eb14391e14c7f3f576fb1673)
+++ src/Actions/MoleculeAction/SaveAdjacencyAction.cpp	(revision 41a467397fe65de7b369f9989fc26e6e18070f2e)
@@ -20,14 +20,12 @@
 #include "CodePatterns/MemDebug.hpp"
 
-#include "Graph/BondGraph.hpp"
-#include "config.hpp"
-#include "CodePatterns/Log.hpp"
-#include "molecule.hpp"
-#include "CodePatterns/Verbose.hpp"
-#include "World.hpp"
-
 #include <iostream>
 #include <fstream>
 #include <string>
+
+#include "CodePatterns/Log.hpp"
+#include "Graph/BondGraph.hpp"
+#include "molecule.hpp"
+#include "World.hpp"
 
 #include "Actions/MoleculeAction/SaveAdjacencyAction.hpp"
Index: src/Actions/MoleculeAction/SaveBondsAction.cpp
===================================================================
--- src/Actions/MoleculeAction/SaveBondsAction.cpp	(revision 47d0416c5a62d6d7eb14391e14c7f3f576fb1673)
+++ src/Actions/MoleculeAction/SaveBondsAction.cpp	(revision 41a467397fe65de7b369f9989fc26e6e18070f2e)
@@ -20,14 +20,12 @@
 #include "CodePatterns/MemDebug.hpp"
 
-#include "Graph/BondGraph.hpp"
-#include "config.hpp"
-#include "CodePatterns/Log.hpp"
-#include "molecule.hpp"
-#include "CodePatterns/Verbose.hpp"
-#include "World.hpp"
-
 #include <iostream>
 #include <fstream>
 #include <string>
+
+#include "CodePatterns/Log.hpp"
+#include "Graph/BondGraph.hpp"
+#include "molecule.hpp"
+#include "World.hpp"
 
 #include "Actions/MoleculeAction/SaveBondsAction.hpp"
Index: src/Actions/MoleculeAction/SuspendInWaterAction.cpp
===================================================================
--- src/Actions/MoleculeAction/SuspendInWaterAction.cpp	(revision 47d0416c5a62d6d7eb14391e14c7f3f576fb1673)
+++ src/Actions/MoleculeAction/SuspendInWaterAction.cpp	(revision 41a467397fe65de7b369f9989fc26e6e18070f2e)
@@ -20,8 +20,6 @@
 #include "CodePatterns/MemDebug.hpp"
 
+#include "CodePatterns/Log.hpp"
 #include "Tesselation/boundary.hpp"
-#include "config.hpp"
-#include "CodePatterns/Log.hpp"
-#include "CodePatterns/Verbose.hpp"
 #include "World.hpp"
 
@@ -30,4 +28,6 @@
 
 #include "Actions/MoleculeAction/SuspendInWaterAction.hpp"
+
+class config;
 
 using namespace MoleCuilder;
Index: src/Dynamics/MinimiseConstrainedPotential.cpp
===================================================================
--- src/Dynamics/MinimiseConstrainedPotential.cpp	(revision 47d0416c5a62d6d7eb14391e14c7f3f576fb1673)
+++ src/Dynamics/MinimiseConstrainedPotential.cpp	(revision 41a467397fe65de7b369f9989fc26e6e18070f2e)
@@ -25,5 +25,4 @@
 
 #include "atom.hpp"
-#include "config.hpp"
 #include "Element/element.hpp"
 #include "CodePatterns/enumeration.hpp"
Index: src/Makefile.am
===================================================================
--- src/Makefile.am	(revision 47d0416c5a62d6d7eb14391e14c7f3f576fb1673)
+++ src/Makefile.am	(revision 41a467397fe65de7b369f9989fc26e6e18070f2e)
@@ -169,5 +169,4 @@
   Box.cpp \
   config.cpp \
-  ConfigFileBuffer.cpp \
   Formula.cpp \
   linkedcell.cpp \
@@ -193,5 +192,4 @@
   Box.hpp \
   config.hpp \
-  ConfigFileBuffer.hpp \
   Formula.hpp \
   linkedcell.hpp \
Index: src/Parser/ConfigFileBuffer.cpp
===================================================================
--- src/Parser/ConfigFileBuffer.cpp	(revision 41a467397fe65de7b369f9989fc26e6e18070f2e)
+++ src/Parser/ConfigFileBuffer.cpp	(revision 41a467397fe65de7b369f9989fc26e6e18070f2e)
@@ -0,0 +1,248 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * ConfigFileBuffer.cpp
+ *
+ *  Created on: 12.06.2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include <iostream>
+#include <boost/tokenizer.hpp>
+#include <string>
+
+#include "ConfigFileBuffer.hpp"
+#include "CodePatterns/Verbose.hpp"
+#include "CodePatterns/Log.hpp"
+#include "Helpers/defs.hpp"
+#include "Helpers/helpers.hpp"
+#include "World.hpp"
+
+/******************************** Functions for class ConfigFileBuffer **********************/
+
+/** Structure containing compare function for Ion_Type sorting.
+ */
+struct IonTypeCompare {
+  bool operator()(std::string s1, std::string s2) const {
+    ConvertTo<int> toInt;
+    boost::char_separator<char> sep("_");
+    tokenizer tokens1(s1,sep);
+    tokenizer tokens2(s2,sep);
+    tokenizer::iterator tok_iter1 = tokens1.begin();
+    tokenizer::iterator tok_iter2 = tokens2.begin();
+    ++tok_iter1;
+    ++tok_iter2;
+
+    std::string element1(*tok_iter1++);
+    std::string element2(*tok_iter2++);
+    int elementno1 = toInt(element1.substr(4,string::npos));
+    int elementno2 = toInt(element2.substr(4,string::npos));
+    if (elementno1 != elementno2)
+      return elementno1 < elementno2;
+    else {
+      std::string atom1(*tok_iter1);
+      std::string atom2(*tok_iter2);
+      int atomno1 = toInt(atom1);
+      int atomno2 = toInt(atom2);
+      return atomno1 < atomno2;
+    }
+
+//    char number1[8];
+//    char number2[8];
+//    const char *dummy1 = s1.c_str();
+//    const char *dummy2 = s2.c_str();
+//    //LOG(0, s1 << "  " << s2);
+//    dummy1 = strchr(s1, '_')+sizeof(char)*5;  // go just after "Ion_Type"
+//    dummy2 = strchr(dummy1, '_');
+//    strncpy(number1, dummy1, dummy2-dummy1); // copy the number
+//    number1[dummy2-dummy1]='\0';
+//    dummy1 = strchr(s2, '_')+sizeof(char)*5;  // go just after "Ion_Type"
+//    dummy2 = strchr(dummy1, '_');
+//    strncpy(number2, dummy1, dummy2-dummy1); // copy the number
+//    number2[dummy2-dummy1]='\0';
+//    if (atoi(number1) != atoi(number2))
+//      return (atoi(number1) < atoi(number2));
+//    else {
+//      dummy1 = strchr(s1, '_')+sizeof(char);
+//      dummy1 = strchr(dummy1, '_')+sizeof(char);
+//      dummy2 = strchr(dummy1, ' ') < strchr(dummy1, '\t') ? strchr(dummy1, ' ') : strchr(dummy1, '\t');
+//      strncpy(number1, dummy1, dummy2-dummy1); // copy the number
+//      number1[dummy2-dummy1]='\0';
+//      dummy1 = strchr(s2, '_')+sizeof(char);
+//      dummy1 = strchr(dummy1, '_')+sizeof(char);
+//      dummy2 = strchr(dummy1, ' ') < strchr(dummy1, '\t') ? strchr(dummy1, ' ') : strchr(dummy1, '\t');
+//      strncpy(number2, dummy1, dummy2-dummy1); // copy the number
+//      number2[dummy2-dummy1]='\0';
+//      return (atoi(number1) < atoi(number2));
+//    }
+  }
+
+  typedef boost::tokenizer<boost::char_separator<char> > tokenizer;
+};
+
+
+/** Constructor for ConfigFileBuffer class.
+ */
+ConfigFileBuffer::ConfigFileBuffer() :
+    buffer(NULL),
+    LineMapping(NULL),
+    CurrentLine(0),
+    NoLines(0)
+{
+};
+
+/** Constructor for ConfigFileBuffer class with filename to be parsed.
+ * \param *filename file name
+ */
+ConfigFileBuffer::ConfigFileBuffer(const char * const filename) :
+    buffer(NULL),
+    LineMapping(NULL),
+    CurrentLine(0),
+    NoLines(0)
+{
+  InitFileBuffer(filename);
+}
+
+void ConfigFileBuffer::InitFileBuffer(const char * const filename)
+{
+  ifstream *file= new ifstream(filename);
+  InitFileBuffer(file);
+}
+
+void ConfigFileBuffer::InitFileBuffer(istream *file)
+{
+  char line[MAXSTRINGSIZE];
+
+  RemoveMapping();
+
+  // prescan number of lines
+  if (file->fail()) {
+    ELOG(1, "config file missing!");
+    return;
+  }
+  NoLines = 0; // we're overcounting by one
+  long file_position = file->tellg(); // mark current position
+  while (file->good()) {
+    file->getline(line, MAXSTRINGSIZE-1);
+    NoLines++;
+  }
+  file->clear();
+  file->seekg(file_position, ios::beg);
+  LOG(1, NoLines-1 << " lines were recognized.");
+
+  // allocate buffer's 1st dimension
+  if (buffer != NULL) {
+    ELOG(1, "FileBuffer->buffer is not NULL!");
+    return;
+  } else
+    buffer = new char *[NoLines];
+
+  // scan each line and put into buffer
+  int lines=0;
+  int i;
+  do {
+    buffer[lines] = new char[MAXSTRINGSIZE];
+    file->getline(buffer[lines], MAXSTRINGSIZE-1);
+    i = strlen(buffer[lines]);
+    buffer[lines][i] = '\n';
+    buffer[lines][i+1] = '\0';
+    lines++;
+  } while((!file->eof()) && (lines < NoLines));
+  LOG(1, lines-1 << " lines were read into the buffer.");
+  file->clear();
+  file->seekg(file_position, ios::beg);
+
+  InitMapping();
+}
+
+/** Destructor for ConfigFileBuffer class.
+ */
+ConfigFileBuffer::~ConfigFileBuffer()
+{
+  RemoveBuffer();
+  RemoveMapping();
+}
+
+
+/** Create trivial mapping.
+ */
+void ConfigFileBuffer::InitMapping()
+{
+  LineMapping = new int[NoLines];
+  for (int i=0;i<NoLines;i++)
+    LineMapping[i] = i;
+  MappingAllocated = true;
+}
+
+/** Remove allocated mapping.
+ */
+void ConfigFileBuffer::RemoveMapping()
+{
+  delete[](LineMapping);
+  MappingAllocated = false;
+}
+
+/** Remove allocated mapping.
+ */
+void ConfigFileBuffer::RemoveBuffer()
+{
+  for(int i=0;i<NoLines;++i)
+    delete[](buffer[i]);
+  delete[](buffer);
+}
+
+
+/** Creates a mapping for the \a *FileBuffer's lines containing the Ion_Type keyword such that they are sorted.
+ * \a *map on return contains a list of NoAtom entries such that going through the list, yields indices to the
+ * lines in \a *FileBuffer in a sorted manner of the Ion_Type?_? keywords. We assume that ConfigFileBuffer::CurrentLine
+ * points to first Ion_Type entry.
+ * \param *FileBuffer pointer to buffer structure
+ * \param NoAtoms of subsequent lines to look at
+ */
+void ConfigFileBuffer::MapIonTypesInBuffer(const int NoAtoms)
+{
+  std::multimap<std::string, int, IonTypeCompare> IonTypeLineMap;
+  if (!MappingAllocated) {
+    InitMapping();
+  }
+
+  typedef boost::tokenizer<boost::char_separator<char> >
+      tokenizer;
+  boost::char_separator<char> sep("\t ");
+
+  // put all into hashed map
+  for (int i=CurrentLine; i<NoLines; ++i) {
+    std::string line(buffer[i]);
+    tokenizer tokens(line, sep);
+    if (tokens.begin() != tokens.end()) {
+      const std::string token = *tokens.begin();
+      if (token.find("Ion_Type") != string::npos) {
+        IonTypeLineMap.insert(pair<std::string, int> (token, i));
+      }
+    }
+  }
+
+  // fill map (aka IonType1_1, IonType1_1, IonType1_1, IonType1_2, IonType1_2, IonType1_2, ...
+  // ..., IonType2_1, IonType2_1, IonType2_1, ...)
+  int nr=0;
+  for (map<std::string, int, IonTypeCompare>::iterator runner = IonTypeLineMap.begin(); runner != IonTypeLineMap.end(); ++runner) {
+    if (CurrentLine+nr < NoLines)
+      LineMapping[CurrentLine+(nr++)] = runner->second;
+    else {
+      ELOG(0, "config::MapIonTypesInBuffer - NoLines is wrong: We are past the end of the file!");
+      performCriticalExit();
+    }
+  }
+}
Index: src/Parser/ConfigFileBuffer.hpp
===================================================================
--- src/Parser/ConfigFileBuffer.hpp	(revision 41a467397fe65de7b369f9989fc26e6e18070f2e)
+++ src/Parser/ConfigFileBuffer.hpp	(revision 41a467397fe65de7b369f9989fc26e6e18070f2e)
@@ -0,0 +1,53 @@
+/*
+ * ConfigFileBuffer.hpp
+ *
+ *  Created on: 12.06.2010
+ *      Author: heber
+ */
+
+#ifndef CONFIGFILEBUFFER_HPP_
+#define CONFIGFILEBUFFER_HPP_
+
+
+/*********************************************** includes ***********************************/
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <iosfwd>
+
+/****************************************** forward declarations *****************************/
+
+/********************************************** declarations *******************************/
+
+class ConfigFileBuffer {
+  public:
+    char **buffer;
+    int *LineMapping;
+    int CurrentLine;
+    int NoLines;
+
+    ConfigFileBuffer();
+    ConfigFileBuffer(const char * const filename);
+    ~ConfigFileBuffer();
+
+    void InitFileBuffer(const char * const filename);
+    void InitFileBuffer(std::istream *file);
+    void MapIonTypesInBuffer(const int NoAtoms);
+
+private:
+
+    /*
+     * Whether LineMapping is allocated or not.
+     */
+    bool MappingAllocated;
+
+    void InitMapping();
+    void RemoveMapping();
+    void RemoveBuffer();
+};
+
+
+#endif /* CONFIGFILEBUFFER_HPP_ */
Index: src/Parser/Makefile.am
===================================================================
--- src/Parser/Makefile.am	(revision 47d0416c5a62d6d7eb14391e14c7f3f576fb1673)
+++ src/Parser/Makefile.am	(revision 41a467397fe65de7b369f9989fc26e6e18070f2e)
@@ -5,4 +5,5 @@
 PARSERSOURCE = \
   Parser/ChangeTracker.cpp \
+  Parser/ConfigFileBuffer.cpp \
   Parser/FormatParser_common.cpp \
   Parser/FormatParser_Parameters.cpp \
@@ -13,4 +14,5 @@
   Parser/ParserTypes.cpp \
   Parser/PcpParser.cpp \
+  Parser/PcpParser_helper.cpp \
   Parser/PdbAtomInfoContainer.cpp \
   Parser/PdbParser.cpp \
@@ -23,4 +25,5 @@
 PARSERHEADER = \
   Parser/ChangeTracker.hpp \
+  Parser/ConfigFileBuffer.hpp \
   Parser/FormatParser.hpp \
   Parser/FormatParser_specializations_header.hpp \
@@ -37,4 +40,5 @@
   Parser/ParserTypes.undef \
   Parser/PcpParser.hpp \
+  Parser/PcpParser_helper.hpp \
   Parser/PdbAtomInfoContainer.hpp \
   Parser/PdbKey.hpp \
Index: src/Parser/MpqcParser.cpp
===================================================================
--- src/Parser/MpqcParser.cpp	(revision 47d0416c5a62d6d7eb14391e14c7f3f576fb1673)
+++ src/Parser/MpqcParser.cpp	(revision 41a467397fe65de7b369f9989fc26e6e18070f2e)
@@ -28,13 +28,12 @@
 
 #include "atom.hpp"
+#include "CodePatterns/Log.hpp"
+#include "CodePatterns/toString.hpp"
 #include "config.hpp"
 #include "Element/element.hpp"
+#include "Element/periodentafel.hpp"
+#include "LinearAlgebra/Vector.hpp"
 #include "molecule.hpp"
 #include "MoleculeListClass.hpp"
-#include "CodePatterns/Log.hpp"
-#include "CodePatterns/toString.hpp"
-#include "CodePatterns/Verbose.hpp"
-#include "LinearAlgebra/Vector.hpp"
-#include "Element/periodentafel.hpp"
 #include "World.hpp"
 
Index: src/Parser/PcpParser.cpp
===================================================================
--- src/Parser/PcpParser.cpp	(revision 47d0416c5a62d6d7eb14391e14c7f3f576fb1673)
+++ src/Parser/PcpParser.cpp	(revision 41a467397fe65de7b369f9989fc26e6e18070f2e)
@@ -23,20 +23,19 @@
 #include <iomanip>
 
-//#include "Actions/FragmentationAction/SubgraphDissectionAction.hpp"
 #include "atom.hpp"
-#include "config.hpp"
-#include "ConfigFileBuffer.hpp"
-#include "Element/element.hpp"
+#include "Box.hpp"
 #include "CodePatterns/Assert.hpp"
 #include "CodePatterns/Log.hpp"
 #include "CodePatterns/Verbose.hpp"
+#include "Element/element.hpp"
+#include "Element/periodentafel.hpp"
 #include "LinearAlgebra/RealSpaceMatrix.hpp"
 #include "molecule.hpp"
 #include "MoleculeListClass.hpp"
 #include "PcpParser.hpp"
-#include "Element/periodentafel.hpp"
+#include "Parser/ConfigFileBuffer.hpp"
+#include "Parser/PcpParser_helper.hpp"
 #include "ThermoStatContainer.hpp"
 #include "World.hpp"
-#include "Box.hpp"
 
 
